package com.gradle.ares

import org.objectweb.asm.MethodVisitor
import org.objectweb.asm.Opcodes

/**
 * Created by Glen on 2017/2/8.
 */

public class MethodAgentVisitor extends MethodVisitor {
    public final static String AgentClass = "com/uddream/plugin/Agent";
    public final static String AgentPluginFileld = "isPluginEnable";
    public final static String AgentPackageField = "packageName";

    public final static MethodModel[] Modify = [
            new MethodModel("onClick", "(Landroid/view/View;)V"),
            new MethodModel("onCheckedChanged", "(Landroid/widget/CompoundButton;Z)V")
    ] as MethodModel[]

    public static MethodModel getAgent(String className, String superName, String name, String desc) {
        for (MethodModel item : Modify) {
            if (item.name.equals(name) && item.desc.equals(desc)) {
                item.className = className
                item.superName = superName
                return item
            }
        }
        return null
    }

    private int pCount;
    private MethodModel agent;

    MethodAgentVisitor(MethodVisitor mv, MethodModel agent) {
        super(Opcodes.ASM5, mv)
        this.agent = agent
        for (def item : agent.desc.substring(1, agent.desc.indexOf(")")).split(";")) {
            if (!item.equals("")) this.pCount++
        }
    }

    @Override
    void visitCode() {
        super.visitCode()
        for (int i = 1; i <= pCount; i++) visitVarInsn(Opcodes.ALOAD, i)
        visitMethodInsn(Opcodes.INVOKESTATIC, AgentClass, agent.name + "Pre", agent.desc, false)
    }

    @Override
    public void visitInsn(int opcode) {
        if (opcode == Opcodes.RETURN) {
            for (int i = 1; i <= pCount; i++) visitVarInsn(Opcodes.ALOAD, i)
            visitMethodInsn(Opcodes.INVOKESTATIC, AgentClass, agent.name, agent.desc, false)
        }
        super.visitInsn(opcode);
    }
}
